/* XDCtools wb_t@C */
#include <xdc/std.h>
#include <xdc/runtime/System.h>

/* BIOS wb_t@C */
#include <ti/sysbios/knl/Task.h>
#include <ti/sysbios/knl/Clock.h>

/* Cwb_t@C */
#include <string.h>
#include <sys/socket.h>

/* [U[`}N */
#define CONSOLE(...) do { System_printf(__VA_ARGS__); System_flush(); } while(0)
#define SLEEP(X) Task_sleep((X)*1000/Clock_tickPeriod)

/*
 * HTTP^XN
 */
Void task_HTTP(UArg arg0, UArg arg1)
{
    int i; // ėpJE^
    int Connection; // uEUƂ̐ڑ
    char Receive_data[400]; // Mobt@
    int receiveDataSize; // Mf[^TCY
    int srcSocket; // \Pbg
    struct sockaddr_in servaddr, cliaddr; // \PbgAhX\
    int addrlen; // NCAg̃AhX

    // HTTPX|X`
    char Response_Header[] = "HTTP/1.0 200 OK\n"
            "Connection: close\n"
            "Content-type: text/html\n"
            "\n";

    // \weby[Whtml \[X
    char page[] = "<!DOCTYPE html>\n"
            "<html>\n"
            "<head>\n"
            "<meta charset='Shift_JIS'>\n"
            "<title>WebT[õeXg</title>\n"
            "</head>\n"
            "<body>\n"
            "Hello, world!\n"
            "</body>\n"
            "</html>\n";

    CONSOLE("HTTP^XN̊Jn\n");

    // T[oi}CRjIPAhXу|[gԍ̐ݒ
    memset(&servaddr, 0, sizeof(servaddr));
    servaddr.sin_family = AF_INET;
    servaddr.sin_addr.s_addr = htonl(INADDR_ANY);
    servaddr.sin_port = htons(80);

    // \Pbg̐
    srcSocket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
    if (srcSocket == -1)
    {
        CONSOLE("\\Pbg̐Ɏs܂I\n");
        return;
    }

    // \Pbg̃oCh
    if (bind(srcSocket, (struct sockaddr*) &servaddr, sizeof(servaddr)) == -1)
    {
        CONSOLE("\\Pbg̃oChɎs܂I\n");
        return;
    }

    // ڑ̋
    if (listen(srcSocket, 4) == -1)
    {
        CONSOLE("ڑ̋Ɏs܂I\n");
        return;
    }

    while (1)
    {
        // ԑ҂
        SLEEP(20);

        // NCAg̃AhX̏
        addrlen = sizeof(cliaddr);

        // ڑt
        Connection = accept(srcSocket, (struct sockaddr*) &cliaddr, &addrlen);
        if (Connection == -1)
        {
            CONSOLE("ڑtɎs܂I\n");
            continue;
        }

        // pPbgMobt@̃NA
        memset(Receive_data, 0, sizeof(Receive_data));

        // pPbgM
        receiveDataSize = recv(Connection, Receive_data, sizeof(Receive_data),0);
        CONSOLE("%doCgM܂B\n", receiveDataSize);

        // Mf[^R\[ɕ\
        CONSOLE("======== Receive_data begin ========\n");
        for (i = 0; i < receiveDataSize; i += 128)
        {
            int j = i + 128;
            if (j < receiveDataSize)
            {
                char c = Receive_data[i + 128];
                Receive_data[i + 128] = '\0';
                CONSOLE("%s", Receive_data + i);
                Receive_data[i + 128] = c;
            }
            else
            {
                CONSOLE("%s", Receive_data + i);
            }
        }
        CONSOLE("\n======== Receive_data end ========\n");

        // HTTPX|X𑗐M
        send(Connection, Response_Header, strlen(Response_Header), 0);

        // html \[X𑗐M
        send(Connection, page, strlen(page), 0);

        // ڑI
        close(Connection);
    }
}
